#!/usr/bin/env python

#This script is meant to be used as a python module
#and outputs a list of files that will be used to build a voice
#using festival multisyn.
#CSTR, Edinburgh: 24/05/07
#Yolanda Vazquez-Alvarez

import sys
import os
import re

# Function

def listFiles( directory, uttsfile, ext = "" ):
    outList = []
    uttsfile_open = open(uttsfile)
    uttsfile_lns = uttsfile_open.readlines()
    #file_pat can be anything between the pattern: ( 'anything' "<capital or lower case letter>
    file_pat = re.compile(r'^\s*(\()\s*(.*)\s+(".*")\s*\)\s*') #filter out lines starting with ';'
    for lines in uttsfile_lns:
        file_root_pat = file_pat.search(lines)
        if file_root_pat:
            file_root = file_root_pat.group(2)
            outList.append(os.path.join(directory,file_root+ext))
            
    outList.sort() #sort filelist
    return  outList

# Change log:
#
# 09/03/26: Rob - added optional space after opening bracket for lines in utts.data
#               - added an optional file extension to the listFiles function
# 11/04/04: Rob - added more optional space


