#ifndef  DEF_VST_H
#define  DEF_VST_H
/*----------------------------------------------------------------------*\
|  18.07.1997  fit for C++ and options -Wall and -pedantic               |
|  13.08.1997  #ifdef VERBMOBIL error messages also sent to tbm vie ICE  |
\*----------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <limits.h>  

/*************************************************************************/
#define bcopy(src, dst, n) memmove(dst, src, n)

/*************************************************************************/
#define  ODD(int_var)       ((int_var)&1)
#define  EVEN(int_var)    (!((int_var)&1))
#define  SQR(x)           ((x)*(x))
#ifndef MIN
    #define  MIN(x,y)         ((x)<(y) ? (x) : (y))
    #define  MAX(x,y)         ((x)>(y) ? (x) : (y))
#endif

/*************************************************************************/
#ifndef __cplusplus
    #ifndef HTK_bool
        typedef enum {FALSE, TRUE } bool;
    #else
        typedef Boolean bool;
    #endif
#else
#define TRUE true
#define FALSE false
#endif
static   int   _I_,         /* fuer USAGE ff. */
               _OBAC_;      /* obl. arg. cnt  */
static   bool  _MAXARGS_ = TRUE;
static   char  *_BOPTSTR_;

/*************************************************************************/
/*             MASCHINENANPASSUNGEN:                                     */
/*************************************************************************/

/* damit auf den Sun's MAXFLOAT und SEEK_SET definiert sind              */
/*-----------------------------------------------------------------------*/
#ifdef sparc
    #include "values.h"
    #include "unistd.h"
    #include "prof.h"
#endif

/* This used to guarantee network byte order. At CSTR always native ord. */
/*-----------------------------------------------------------------------*/
// #if defined(solaris) || defined(sgi)
//     #define swab(buf, typ, nval)   0
// #else
//     #define swab(buf, typ, nval)   swab_ ## typ(buf, (nval)*sizeof(typ))
// #endif

#define swab(buf, typ, nval)   0

/* die swabN() - Funktionen stehen in dsp.a                               */
#define swab_short(buf, nbytes)   swab2(buf, NULL, nbytes)
#define swab_float(buf, nbytes)   swab4(buf, NULL, nbytes)
#define swab_long(buf, nbytes)    swab4(buf, NULL, nbytes)
#define swab_int(buf, nbytes)     swab4(buf, NULL, nbytes)
#define swab_double(buf, nbytes)  swab8(buf, NULL, nbytes)
#define swab_char(buf, nbytes)    0

/*-----------------------------------------------------------------------*\
|      manche limits.h - Versionen kennen kein FLT_MAX /_MIN, z.B.        |
|"/usr/fau/gnu_comp/lib/gcc-lib/mips-dec-ultrix/2.3.1/include/limits.h"   |
\*-----------------------------------------------------------------------*/
#ifndef  FLT_MAX 
    #ifndef MAXFLOAT               /* Tue Feb 22 11:13:01 GMT 2005 */
        #define MAXFLOAT HUGE      /* on sleer.inf.ed.ac.uk        */
    #endif
    #define FLT_MAX  MAXFLOAT     /* das sollte in math.h definiert sein */
    #define FLT_MIN  -(MAXFLOAT)
#endif

/*************************************************************************/
/* macros ERRORn, MESSAGEn, and DMESSAGEn expanded for n<3 to avoid      */
/* warnings with -Wall option (18.07.1997, vst)                          */

#define end_do                 while(0)
#define NAME(str)              static char *argv[1]={str}
#define CR                     fputc('\n',stderr)

#ifdef VERBMOBIL
/*-----------------------------------------------------------------------*\
|  In VM2 (if __COMMBONNH__ is defined) these variables are no longer     |
|  used.                                                                  |
\*-----------------------------------------------------------------------*/
#ifdef COMMBONN
    #include <prosgenerror.h>
#endif

static char _ems1[200], _ems2[100];

#define ERROR3(str,a1,a2,a3)   (fprintf(stderr,"ERROR IN \"%s\", line %d: ",\
                                argv[0], __LINE__),\
                                fprintf(stderr,str,a1,a2,a3),CR,\
                                sprintf(_ems1, \
                                        "ERROR IN \"%s\", line %d: ",\
                                       argv[0], __LINE__),\
                                sprintf(_ems2,str,a1,a2,a3),\
                                strcat(_ems1, _ems2),\
                                prosGenPutInfo(ProsGenError, _ems1),\
                                -1\
                               )
#define ERROR2(str,a1,a2   )   (fprintf(stderr,"ERROR IN \"%s\", line %d: ",\
                                argv[0], __LINE__),\
                                fprintf(stderr,str,a1,a2   ),CR,\
                                sprintf(_ems1, \
                                        "ERROR IN \"%s\", line %d: ",\
                                       argv[0], __LINE__),\
                                sprintf(_ems2,str,a1,a2),\
                                strcat(_ems1, _ems2),\
                                prosGenPutInfo(ProsGenError, _ems1),\
                                -1\
                               )
#define ERROR1(str,a1      )   (fprintf(stderr,"ERROR IN \"%s\", line %d: ",\
                                argv[0], __LINE__),\
                                fprintf(stderr,str,a1      ),CR,\
                                sprintf(_ems1, \
                                        "ERROR IN \"%s\", line %d: ",\
                                       argv[0], __LINE__),\
                                sprintf(_ems2,str,a1),\
                                strcat(_ems1, _ems2),\
                                prosGenPutInfo(ProsGenError, _ems1),\
                                -1\
                               )
#define ERROR0(str         )   (fprintf(stderr,"ERROR IN \"%s\", line %d: ",\
                                argv[0], __LINE__),\
                                fprintf(stderr,str         ),CR,\
                                sprintf(_ems1, \
                                        "ERROR IN \"%s\", line %d: ",\
                                       argv[0], __LINE__),\
                                sprintf(_ems2,str),\
                                strcat(_ems1, _ems2),\
                                prosGenPutInfo(ProsGenError, _ems1),\
                                -1\
                               )
#else

#define ERROR3(str,a1,a2,a3)   (fprintf(stderr,"ERROR IN \"%s\", line %d: ",\
                                argv[0], __LINE__),\
                                fprintf(stderr,str,a1,a2,a3),CR,exit(1),-1\
                               )
#define ERROR2(str,a1,a2   )   (fprintf(stderr,"ERROR IN \"%s\", line %d: ",\
                                argv[0], __LINE__),\
                                fprintf(stderr,str,a1,a2   ),CR,exit(1),-1\
                               )
#define ERROR1(str,a1      )   (fprintf(stderr,"ERROR IN \"%s\", line %d: ",\
                                argv[0], __LINE__),\
                                fprintf(stderr,str,a1      ),CR,exit(1),-1\
                               )
#define ERROR0(str         )   (fprintf(stderr,"ERROR IN \"%s\", line %d: ",\
                                argv[0], __LINE__),\
                                fprintf(stderr,str         ),CR,exit(1),-1\
                               )
#endif /*VERBMOBIL*/
#define PROG_ERROR             ERROR0("no way");
/*************************************************************************/
#define MESSAGE4(str,a1,a2,a3,a4) do \
                               {fprintf(stderr,"MESSAGE FROM \"%s\": ",\
                                argv[0]);\
                                fprintf(stderr,str,a1,a2,a3,a4);CR;\
                               } end_do
#define MESSAGE3(str,a1,a2,a3   ) do \
                               {fprintf(stderr,"MESSAGE FROM \"%s\": ",\
                                argv[0]);\
                                fprintf(stderr,str,a1,a2,a3   );CR;\
                               } end_do
#define MESSAGE2(str,a1,a2      ) do \
                               {fprintf(stderr,"MESSAGE FROM \"%s\": ",\
                                argv[0]);\
                                fprintf(stderr,str,a1,a2      );CR;\
                               } end_do
#define MESSAGE1(str,a1         ) do \
                               {fprintf(stderr,"MESSAGE FROM \"%s\": ",\
                                argv[0]);\
                                fprintf(stderr,str,a1         );CR;\
                               } end_do
#define MESSAGE0(str            ) do \
                               {fprintf(stderr,"MESSAGE FROM \"%s\": ",\
                                argv[0]);\
                                fprintf(stderr,str            );CR;\
                               } end_do
/*************************************************************************/
#define ITRACE(i)  fprintf(stderr,"%s = %d\n", #i, i)

#define LTRACE(l)  fprintf(stderr,"%s = %ld\n", #l, l)

#define FTRACE(f)  fprintf(stderr,"%s = %g\n", #f, f)

#define BTRACE(b)  do{ if(b) fprintf(stderr,"%s = TRUE\n", #b); \
                       else  fprintf(stderr,"%s = FALSE\n", #b); \
                   } end_do

#define STRACE(s)  fprintf(stderr,"%s = %s\n", #s, s)

#define PTRACE(p)  fprintf(stderr,"%s = %p\n", #p, p)

/*************************************************************************/
#ifndef IF_DEBUG
#define IF_DEBUG if(getenv("DEBUG"))
#endif

#define DMESSAGE4(str,a1,a2,a3,a4) \
do \
    IF_DEBUG \
    {   fprintf(stderr,"DMESSAGE FROM \"%s\": ",\
        argv[0]);\
        fprintf(stderr,str,a1,a2,a3,a4);CR;\
    } end_do
#define DMESSAGE3(str,a1,a2,a3   ) \
do \
    IF_DEBUG \
    {   fprintf(stderr,"DMESSAGE FROM \"%s\": ",\
        argv[0]);\
        fprintf(stderr,str,a1,a2,a3   );CR;\
    } end_do
#define DMESSAGE2(str,a1,a2      ) \
do \
    IF_DEBUG \
    {   fprintf(stderr,"DMESSAGE FROM \"%s\": ",\
        argv[0]);\
        fprintf(stderr,str,a1,a2      );CR;\
    } end_do
#define DMESSAGE1(str,a1         ) \
do \
    IF_DEBUG \
    {   fprintf(stderr,"DMESSAGE FROM \"%s\": ",\
        argv[0]);\
        fprintf(stderr,str,a1         );CR;\
    } end_do
#define DMESSAGE0(str            ) \
do \
    IF_DEBUG \
    {   fprintf(stderr,"DMESSAGE FROM \"%s\": ",\
        argv[0]);\
        fprintf(stderr,str            );CR;\
    } end_do
/*************************************************************************/
#define FOPEN(fd,name,mode)\
                do \
        if(!(fd = fopen(name, mode)))\
            ERROR2("cannot fopen file <%s> for `%s`",\
                    name, mode); \
                end_do

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
static   int  _NBR_,      /* # bytes read                                 */
              _NVR_,      /* # of values read = _NBR_/sizeof(type)        */
              _RMD_;      /* remainder        = _NBR_&sizeof(type)        */

#define UP_TO        0    /* Parameter `chk_nr' in FREAD                  */
#define EXACTLY      1    /* Parameter `chk_nr' in FREAD                  */
#define FORCE        2    /* Parameter `chk_nr' in FREAD                  */

#ifdef FWRITE_IMMEDIATELY
    #define FFLUSH(fd)  fflush(fd)
#else
    #define FFLUSH(fd)  TRUE
#endif

#define FWRITEs(ptr, typ, nr, fd, swabtyp)\
                do \
                {   swab(ptr, swabtyp, (nr)*sizeof(typ)/sizeof(swabtyp)); \
                    if(nr != fwrite(ptr, sizeof(typ), nr, fd))\
                    ERROR2 ("cannot FWRITE %d %ss",\
                                nr, #typ); \
                    FFLUSH(fd); \
                } end_do

/* unter BSD musste die erste Anweisung  FFLUSH(fd) sein */

#define FREADs(ptr, typ, chk_nr, nr, fd, swabtyp)\
(   _NBR_=fread(ptr, 1, sizeof(typ)*(nr), fd),\
   _NVR_=_NBR_/sizeof(typ),\
   _RMD_=_NBR_%sizeof(typ),\
   _RMD_ ?\
       ERROR3("while FREADing %d %ss: %d bytes rest", nr, #typ, _RMD_) :\
       chk_nr && _NVR_<(nr) && (_NVR_ || chk_nr==FORCE) ?\
           ERROR3("can only FREAD %d %ss of %d", _NVR_, #typ, nr) :\
           swab(ptr, swabtyp, _NBR_/sizeof(swabtyp)), \
           _NVR_ \
)

#define FREAD(  ptr, typ, chk_nr, nr, fd)\
        FREADs( ptr, typ, chk_nr, nr, fd, typ)
#define FWRITE( ptr, typ,         nr, fd)\
        FWRITEs(ptr, typ,         nr, fd, typ)\
/*------------------------------------------------------------------------*\
|  ptr:      Pointer auf den Anfang des Puffers.                           |
|  typ:      ein Datentyp (auch zusammengesetzt). Beim Lesen wird ueber-   |
|            prueft, ob Bytes uebrigbleiben                                |
|  swabtyp:  {short,int,long,float,double}  NICHT 2 Woerter wie `short int'|
|            Dieser Typ ist fuer das Byte-Swapping relevant. Falls `typ'   |
|            z.B. ein struct aus floats ist, muss `swabtyp' float sein.    |
|            Wenn `typ'==`swabtyp' ist, kann FREAD und FWRITE, statt FREADs|
|            und FWITEs verwendet werden.                                  |
|            Fuer structs aus verschiedenen Typen schreibe man am besten   |
|            seine eigenen IO-Funktionen.                                  |
|  nr:       Anzahl der Werte (der Groesse sizeof(typ)), die gelesen/ge-   |
|            schrieben werden sollen.                                      |
|  chk_nr:   entweder EXACTLY (dann muessen genau `nr' oder 0 Werte lesbar |
|            sein)  oder UP_TO (dann duerfen es auch weniger sein), oder   |
|            FORCE (dann muessen genau `nr' Werte lesbar sein).            |
|  fd:       File-Pointer                                                  |
|                                                                          |
|  FREAD(s) ist das EINZIGE Macro, das einen Wert zurueckgibt: die Anzahl  |
|  der gelesenen Werte; dadurch kann man es in while(FREAD(...)) klammern. |
\*------------------------------------------------------------------------*/



#define ALLOCATE(ptr,typ,nr)\
                do \
                if(!(ptr = (typ*)(calloc (nr, sizeof(typ)))))\
                 ERROR2 ("cannot ALLOCATE %d %ss",\
                     nr, #typ); \
                end_do

#define REALLOCATE(ptr,typ,nr)\
                do \
                if(!(ptr = (typ*)(realloc (ptr, (nr)*sizeof(typ)))))\
                 ERROR2 ("cannot REALLOCATE %d %ss",\
                     nr, #typ); \
                end_do

#define FSEEK(fd, typ, offset, ptrname)\
                do \
                if(fseek(fd, sizeof(typ) * (offset), ptrname) == -1)\
                    ERROR3("cannot FSEEK %d %ss from %s",\
                            offset, #typ, #ptrname);\
                end_do

#define FTELL(fd, typ)\
                ((_I_ = ftell(fd), _I_%sizeof(typ)==0) ?\
                 (_I_/sizeof(typ)) :\
                 (fprintf(stderr,"%s line %d: rest %d in FTELL\n",\
                          argv[0],__LINE__,_I_%sizeof(typ)),\
                  _I_/sizeof(typ)\
                ))

#define FREE(ptr)\
                do \
        if(!(ptr))\
                        ERROR0("cannot free NULL pointer"); \
                end_do

/*************************************************************************/
#define MAIN   int main(int argc, char *argv[])

#ifdef __COMMBONNH__
    #define print_synopsis {putInfo(ProsGenError,synopsis); fputs(synopsis,stderr); return(0);}
#else
    #define print_synopsis {fputs(synopsis,stderr);exit(1);}
#endif

#define isnumstr(s) ((isdigit(s[0]) || (s[0]=='.' && isdigit(s[1])))   ||\
       (s[0]=='-' && (isdigit(s[1]) || (s[1]=='.' && isdigit(s[2])))))

#define isintstr(s) (isnumstr(s) && (strchr(s,'.')==NULL))

#define USAGE(minargs,maxargs)\
    if (--argc<minargs || argc>maxargs ||\
          (argc && argv[1][0]=='-' && argv[1][1]=='h')\
       )\
    {fputs(synopsis,stderr);exit(1);}

#define XARGS(minargs, boptstr, voptstr) \
    do \
    {   _MAXARGS_ = FALSE; \
        ARGS(minargs, boptstr, voptstr); \
    } end_do

#define NUMBER_OF_OBL_ARGS _OBAC_

#define ARGS(minargs, boptstr, voptstr) \
do \
{   if ((--argc < minargs) || \
        (_MAXARGS_ && (argc>(int)(minargs+strlen(boptstr)+2*strlen(voptstr)))) || \
        (argc && argv[1][0]=='-' && argv[1][1]=='h')) \
        {fputs(synopsis,stderr);exit(1);} \
    _I_ = 1; _OBAC_ = 0; _BOPTSTR_=boptstr; \
    while(_I_ <= argc) \
    {   if(argv[_I_][0] != '-' || isdigit(argv[_I_][1])) \
        {   _OBAC_++; \
            _I_++; \
        } \
        else \
        {   if(argv[_I_][2]!=0) \
                ERROR1("a space must follow option char %c",argv[_I_][1]);\
            if(strchr(boptstr,argv[_I_][1])) \
                _I_++; \
            else if(strchr(voptstr,argv[_I_][1])) \
                _I_+=2; \
            else \
                ERROR1("illegal option \"%s\"",argv[_I_]); \
        } \
    } \
    if(_MAXARGS_ && _OBAC_!=minargs) \
        ERROR2("%d instead of %d oblig. args are given",_OBAC_,minargs); \
    _NBR_=_NVR_=_RMD_=0;\
} end_do
                
#define IARG(argn, int_var) \
    do \
    {   _I_ = 1; _OBAC_ = 0; \
        while(_I_ <= argc) \
        {   if(argv[_I_][0] != '-' || isdigit(argv[_I_][1])) \
            {   if(++_OBAC_==argn) \
                {   if(isintstr(argv[_I_])) \
                        int_var   = atoi(argv[_I_]); \
                    else \
                        ERROR1("argv[%d] isn't an integer",_I_); \
                    DMESSAGE2("%s = %d", #int_var, int_var); \
                    break; \
                } \
                _I_++; \
            } \
            else \
                if(strchr(_BOPTSTR_,argv[_I_][1])) \
                    _I_++; \
                else \
                    _I_+=2; \
        } \
    } end_do

#define FARG(argn, float_var)  \
    do \
    {   _I_ = 1; _OBAC_ = 0; \
        while(_I_ <= argc) \
        {   if(argv[_I_][0] != '-' || isdigit(argv[_I_][1])) \
            {   if(++_OBAC_==argn) \
                {   if(isnumstr(argv[_I_])) \
                        float_var = atof(argv[_I_]); \
                    else \
                        ERROR1("argv[%d] isn't a number",_I_); \
                    DMESSAGE2("%s = %g", #float_var, float_var); \
                    break; \
                } \
                _I_++; \
            } \
            else \
                if(strchr(_BOPTSTR_,argv[_I_][1])) \
                    _I_++; \
                else \
                    _I_+=2; \
        } \
    } end_do

#define SARG(argn, str_var)  \
    do \
    {   _I_ = 1; _OBAC_ = 0; \
        while(_I_ <= argc) \
        {   if(argv[_I_][0] != '-' || isdigit(argv[_I_][1])) \
            {   if(++_OBAC_==argn) \
                {   str_var = argv[_I_]; \
                    DMESSAGE2("%s = %s", #str_var, str_var); \
                    break; \
                } \
                _I_++; \
            } \
            else \
                if(strchr(_BOPTSTR_,argv[_I_][1])) \
                    _I_++; \
                else \
                    _I_+=2; \
        } \
    } end_do

#define BOPT(c, bool_var) \
    do { \
    bool_var = FALSE; \
    for(_I_=1; _I_<=argc; _I_++) \
        if(argv[_I_][0]=='-' && argv[_I_][1]==c) \
        {   bool_var = TRUE; \
            DMESSAGE2("option %s: %s = TRUE",argv[_I_],#bool_var); \
        } \
    } end_do

#define IOPT(c, int_var, default) \
    do { \
    int_var = default; \
    for(_I_=1; _I_<=argc; _I_++) \
        if(argv[_I_][0]=='-' && argv[_I_][1]==c) \
        {   if(_I_==argc) \
                ERROR1("option \"%s\" must precede an int",argv[_I_]); \
            else \
               _I_++; \
            if(isintstr(argv[_I_])) \
            {   int_var = atoi(argv[_I_]); \
                DMESSAGE3("option %s: %s = %d", argv[_I_-1], \
                          #int_var, int_var); \
            } \
            else \
                ERROR1("an int must follow \"%s\"",argv[_I_-1]); \
        } \
    } end_do

#define FOPT(c, float_var, default) \
    do { \
    float_var = default; \
    for(_I_=1; _I_<=argc; _I_++) \
        if(argv[_I_][0]=='-' && argv[_I_][1]==c) \
        {   if(_I_==argc) \
               ERROR1("option \"%s\" must precede a float",argv[_I_]); \
            else \
               _I_++; \
            if(isnumstr(argv[_I_])) \
            {   float_var = atof(argv[_I_]); \
                DMESSAGE3("option %s: %s = %g", argv[_I_-1], \
                          #float_var, float_var); \
            } \
            else \
                ERROR1("a float must follow \"%s\"",argv[_I_-1]); \
        } \
    } end_do

#define SOPT(c, str_var, default) \
    do { \
    str_var = default; \
    for(_I_=1; _I_<=argc; _I_++) \
        if(argv[_I_][0]=='-' && argv[_I_][1]==c) \
        {   if(_I_==argc) \
              ERROR1("option \"%s\" must precede a string",argv[_I_]);\
            else \
               _I_++; \
				ALLOCATE(str_var, char, strlen(argv[_I_])+1); \
				strcpy(str_var, argv[_I_]); \
            DMESSAGE3("option %s: %s = %s", argv[_I_-1], \
                      #str_var, str_var); \
        } \
    } end_do

/*************************************************************************/
/*  The following definition avoid warnings "<VAR> defined but not used" */
/*  with option -Wall. To avoid the warning: "`_BECAUSE_Wall' defined    */
/*  but not used" use it once in each module.                            */

static void _BECAUSE_Wall(void)
{  _I_=_OBAC_=_NBR_=_NVR_=_RMD_=0;
   _MAXARGS_=FALSE; _BOPTSTR_=NULL;
#ifdef VERBMOBIL
    _ems1[0]=_ems2[0]=0;
#endif
}
/*=======================================================================*/
#endif  /**  DEF_VST_H  **/
